#!/usr/bin/python
# -*-coding: utf-8-*-

import math

def w2(x):
    y2 = math.cos(x) - x
    return y2

def bisektion_gb(a,b): # Nullstelle mit Bisektion
    if (w2(a)*w2(b) > 0):
        print('a,b sind unzulaessige Startwerte')
        return
#   end if
    it = 0; x = b
    w2x = w2(x)
    while (abs(w2x) > 1.0e-8):
        x = (b+a)/2
        w2x = w2(x)
        if (w2x*w2(a) < 0):
            b = x
        else:
            a = x
#       end if
        it = it +1
#        print(x,it)
#   end while
    return x, it

def main():
    a = 0
    b = math.pi/2

    x, it = bisektion_gb(a,b)

    print(x)
    print(it)

if __name__ == '__main__':
    main()

