#!/usr/bin/python
# -*-coding: utf-8-*-

# Programm 2.2
# Loesung des linearen Gleichungssystems lr x = b
# input:  Matrix a (enthaelt l,r) und Buchhaltungsvektor z
#         als Ergebnis von Programm lr_gb
#         Spaltenvektor b als rechte Seite
# output: Loesung x
# Aufruf: x = lrloes_gb(a,b,z)

def lrloes_gb(a, b, z):
    n = len(a)
    y = list(range(0,n)); x = list(range(0,n))
    for i in range(0,n):
        y[i] = b[z[i]]
    b = y
#   Vorwaertseinsetzen
    for i in range(0,n):
        y[i] = b[i]  #  y(i).lvalue = b(i)
        for j in range(0,i): # for j=1:i-1 ! Achtung
            y[i] = y[i] - a[i][j]*y[j]  #  y(i).lvalue = y(i) - a(i, j) * y(j)
#       endfor
#   endfor
#   Zweiter("Schritt")
    x[n-1] = y[n-1]/a[n-1][n-1]  #  x(n).lvalue = y(n)/a(n, n)
    for l in range(0,n-1):  #  mslice[n - 1:-1:1]:
        k = n-2-l
        c = y[k]
        for j in range(k+1,n):  #  mslice[k + 1:n]:
            c = c - a[k][j]*x[j]
#       endfor
        x[k] = c/a[k][k]  #  x(k).lvalue = c / a(k, k)
#   endfor
    return x  #   x = x.cT
#   endfunction
