#!/usr/bin/python
# -*-coding: utf-8-*-

import numpy as np

# Programm ito_integral_gb.m : Ito-Integral
#              / 
# Ito Integral | X dW , 
#              /

def ito_integral_gb(X,dW,N):
    xh = np.zeros(N+1)
    ito = np.zeros(N)
    xh[0] = 0
    for j in range(1,N+1):
        xh[j] = X[j-1]
#   endfor
    if ( N < 2 ):
        wito = 0
    else:
        for j in range(0,N-1):
            ito[j] = np.dot(xh[0:j+2],dW[0:j+2])
#       endfor
#   endif
    if ( N < 2 ):
        wito = 0
    else:
        wito = ito[N-2]
# endfunction
    return (wito) # , ito[0:N-1], xh, dW)
# endfunction
