#!/usr/bin/python
# -*-coding: utf-8-*-

# import math
import numpy as np
# import numpy.linalg as linalg
# import scipy.linalg as L


# Programm 7.1a Test auf positive Definitheit
# input:  Matrix a
# output: 1 -> pos. def., 0 -> nicht pos. def.

def testpd_gb(a): 
# function [flag]=testpd_gb(a);
    
    n = len(a)
    at = np.transpose(a)
    for i in range(0,n):
        for k in range(0,n):
            if (a[i,k] != at[k,i]):
                s = 0
                print('Matrix ist nicht symmetrisch')
                break
            else:
                s = 1
                continue
#           endif
#       endfor
#   endfor
    ew,ev = np.linalg.eig(a)
#   print(ew)
#   temp = eig(a+a');
    for i in range(0,n):
        re = ew[i].real
        im = ew[i].imag
        if (im != 0):
            print('Matrix hat komplexe Eigenwerte')
            s = 0
            break
#       endif        
#       im = eig(i).imag
        if (re <= 0.000000000001):
            print('Matrix ist nicht positiv definit')
            s = 0
            break
        else:
            continue
#       endif
#   endfor
# Man kann natuerlich den Test auf pos. Definitheit ueber
# eine Cholesky-Zerlegung machen, existiert diese, ist die Matrix
# pos. definit
    return s
#endfunction
